=begin
btm_Sculpt2_Bulge.rb

Copyright 2009, btmsketchup@hotmail.com

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Created by •BTM on 02/07/09.

Name:			Bulge (sculpt tools)
Version:		0.1 (beta)
Description:	Bulges geometry on a mesh, in a way similar to 'brushing' on the mesh.
Usage:			Set the settings of the tool with the Sculpt Tools Dialog, and use it by 'brushing' on the mesh, with the left mouse button held down.
=end
require 'sketchup.rb'
#===================================================================================
class BulgeSculpt
#===================================================================================
	def activate
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	@model = Sketchup.active_model
	@entities = @model.active_entities
	@points = []
	
	@max_thing = $btm_sculpt_radius
	@percent = $btm_sculpt_strength
	@area = $btm_sculpt_area
	@gravity = $btm_sculpt_gravity
	@kind = $btm_sculpt_trans
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	end
#===================================================================================
	def onLButtonDown(flags,x,y,view)
	@model.start_operation "Sculpt Bulge"
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			@entities.each do |e|
				if e.is_a? Sketchup::Edge
				@points << e.start
				@points << e.end
				end
			end
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		@points.uniq!
	end
#===================================================================================
	def onMouseMove(flags, x, y, view)
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		if flags == $btm_sculpt_platform + MK_LBUTTON or flags == $btm_sculpt_platform + MK_LBUTTON + MK_SHIFT
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		ip1 = view.inputpoint x,y
		pt1 = ip1.position
		@mouse_point = Geom::Point3d.new pt1
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			@entities.each do |f|
				if f.is_a? Sketchup::Face and @mouse_point.on_plane? f.plane
					if flags == $btm_sculpt_platform + MK_LBUTTON
					@vector = f.normal
					elsif flags == $btm_sculpt_platform + MK_LBUTTON + MK_SHIFT
					@vector = f.normal.reverse!
					end
				end
			end
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			@points.each do |p|
			pos = p.position
			dist = pos.distance @mouse_point
			radius = @max_thing + @area
			in_dist = dist - @area
			half_dist = @max_thing /2
			dist_from_half = half_dist - in_dist
				if @area < dist  and dist <= radius
					if @kind == "s curve"
					@vector.length = ((radius / ( 1 + E**-(5/ half_dist*dist_from_half)**1))/ 1000)*@percent
					else
					@vector.length = ((radius - dist)/ 1000)*@percent
					end
				@entities.transform_entities(@vector,p)
					if @gravity != 0
					pos2 = p.position
					change = pos.distance pos2
					drop = -(change / 100)*@gravity
					vector2 = Geom::Vector3d.new [ 0, 0, drop]
					@entities.transform_entities(vector2,p)
					end
				
				elsif dist <= @area
					@vector.length = (radius/ 1000)*@percent
				@entities.transform_entities(@vector,p)
					if @gravity != 0
					pos2 = p.position
					change = pos.distance pos2
					drop = -(change / 100)*@gravity
					vector2 = Geom::Vector3d.new [ 0, 0, drop]
					@entities.transform_entities(vector2,p)
					end
				end
			end
		end
	end
#===================================================================================
end		
		mgp = UI::Command.new("Bulge") { Sketchup.active_model.select_tool BulgeSculpt.new }
		$btm_sculpt_menu.add_item mgp
		mgp.large_icon = "btm_sculpt2_bulge1.png"
    mgp.small_icon = "btm_sculpt2_bulge1x16.png"
		mgp.tooltip = "Bulge"
		toolbar = $btm_sculpt_toolbar.add_item mgp
		case toolbar.get_last_state
		when 1
			toolbar.restore
		when -1   
			toolbar.show
		end