=begin
btm_Sculpt3_Push.rb

Copyright 2009, btmsketchup@hotmail.com

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Created by •BTM on 02/07/09.

Name:			Push (sculpt tools)
Version:		0.1 (beta)
Description:	pushes points away from the cursor.
Usage:			Set the settings of the tool with the Sculpt Tools Dialog, and use it by 'brushing' on or near the mesh, with the left mouse button held down.
=end
require 'sketchup.rb'
#===================================================================================
class PushSculpt
#===================================================================================
	def activate
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	@model = Sketchup.active_model
	@entities = @model.active_entities
	@points = []
	
	@max_thing = $btm_sculpt_radius
	@percent = $btm_sculpt_strength
	@area = $btm_sculpt_area
	@gravity = $btm_sculpt_gravity
	@kind = $btm_sculpt_trans
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	end
#===================================================================================
	def onLButtonDown(flags,x,y,view)
	@model.start_operation "Sculpt Push"
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			@entities.each do |e|
				if e.is_a? Sketchup::Edge
				@points << e.start
				@points << e.end
				end
			end
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		@points.uniq!
	end
#===================================================================================
	def onMouseMove(flags, x, y, view)
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		if flags == $btm_sculpt_platform + MK_LBUTTON or flags == $btm_sculpt_platform + MK_LBUTTON + MK_SHIFT
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		ip1 = view.inputpoint x,y
		pt1 = ip1.position
		@mouse_point = Geom::Point3d.new pt1
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			@points.each do |p|
			pos = p.position
			dist = pos.distance @mouse_point
			radius = @max_thing + @area
			half_dist = @max_thing /2
			in_dist = dist - @area
			dist_from_half = half_dist - in_dist
				if @area < dist and dist <= radius
				vec = @mouse_point.vector_to pos
					if flags == $btm_sculpt_platform + MK_LBUTTON + MK_SHIFT
					vec.reverse!
					end
					
					if @kind == "s curve"
						if vec != [ 0, 0, 0]
						vec.length = ((radius / ( 1 + E**-(5/ half_dist*dist_from_half)**1))/ 500)*@percent
						end
					else
						if vec != [ 0, 0, 0]
						vec.length = ((radius - dist)/ 500)*@percent
						end
					end
				@entities.transform_entities(vec,p)
					if @gravity != 0
					pos2 = p.position
					change = pos.distance pos2
					drop = -(change / 100)*@gravity
					vector2 = Geom::Vector3d.new [ 0, 0, drop]
					@entities.transform_entities(vector2,p)
					end
				
				elsif dist <= @area
				vec = @mouse_point.vector_to pos
					if flags == $btm_sculpt_platform + MK_LBUTTON + MK_SHIFT
					vec.reverse!
					end
					if vec != [ 0, 0, 0]
					vec.length = (radius/ 500)*@percent
					end
				@entities.transform_entities(vec,p)
					if @gravity != 0
					pos2 = p.position
					change = pos.distance pos2
					drop = -(change / 100)*@gravity
					vector2 = Geom::Vector3d.new [ 0, 0, drop]
					@entities.transform_entities(vector2,p)
					end
				end
			end
		end
	end
#===================================================================================
end
		mgp = UI::Command.new("Push") { Sketchup.active_model.select_tool PushSculpt.new }
		$btm_sculpt_menu.add_item mgp
		mgp.large_icon = "btm_sculpt3_push1.png"
    mgp.small_icon = "btm_sculpt3_push1x16.png"
		mgp.tooltip = "Push"
		toolbar = $btm_sculpt_toolbar.add_item mgp
		case toolbar.get_last_state
		when 1
			toolbar.restore
		when -1   
			toolbar.show
		end