=begin
btm_Sculpt4_smooth.rb

Copyright 2009, btmsketchup@hotmail.com

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Created by •BTM on 02/07/09.

Name:			Smooth (sculpt tools)
Version:		0.1 (beta)
Description:	Smooths out a mesh.
Usage:			Set the settings of the tool with the Sculpt Tools Dialog, and use it by 'brushing' on the mesh, with the left mouse button held down.
=end
require 'sketchup.rb'
#===================================================================================
class SculptSmooth
#===================================================================================
	def activate
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	@model = Sketchup.active_model
	@entities = @model.active_entities
	@points = []
	
	@max_thing = $btm_sculpt_radius
	@percent = $btm_sculpt_strength
	@area = $btm_sculpt_area
	@gravity = $btm_sculpt_gravity
	@kind = $btm_sculpt_trans
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
	end
#===================================================================================
	def onLButtonDown(flags,x,y,view)
	@model.start_operation "Sculpt Smooth"
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			@entities.each do |e|
				if e.is_a? Sketchup::Edge
				@points << e.start
				@points << e.end
				end
			end
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		@points.uniq!
	end
#===================================================================================
	def onMouseMove(flags, x, y, view)
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		if flags == $btm_sculpt_platform + MK_LBUTTON or flags == $btm_sculpt_platform + MK_LBUTTON + MK_SHIFT
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
		ip1 = view.inputpoint x,y
		pt1 = ip1.position
		@mouse_point = Geom::Point3d.new pt1
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			@points.each do |p|
			pos = p.position
			dist = pos.distance @mouse_point
			radius = @max_thing + @area
			in_dist = dist - @area
			half_dist = @max_thing /2
			dist_from_half = half_dist - in_dist
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			pedges = []
			mathpoints = []
			edgecount = 0
			pedges = p.edges
			
				pedges.each do |l|
				edgecount = edgecount + 1
					if p == l.start
					mathpoints << l.end.position
					elsif p == l.end
					mathpoints << l.start.position
					end
				end
			
			@mean = []
			@mean = [ 0, 0, 0]
				mathpoints.each do |m|
				@mean[0] = @mean[0] + m.to_a[0]
				@mean[1] = @mean[1] + m.to_a[1]
				@mean[2] = @mean[2] + m.to_a[2]
				end
			@mean[0] = @mean[0] /edgecount
			@mean[1] = @mean[1] /edgecount
			@mean[2] = @mean[2] /edgecount
			@vector = pos.vector_to @mean
			meandist = pos.distance @mean
#     -     -     -     -     -     -     -     -     -     -     -     -     -    -
			distpermean = (dist/ radius)*meandist
					
				if @area < dist  and dist <= radius
					if @kind == "s curve"
						if @vector != [ 0, 0, 0]
						@vector.length = ((meandist / ( 1 + E**-(5/ half_dist*dist_from_half)**1))/ 100)*@percent
						end
					else
						if @vector != [ 0, 0, 0]
						@vector.length = ((meandist - distpermean) / 100)*@percent
						end
					end
					if @vector != [ 0, 0, 0]
					@entities.transform_entities(@vector,p)
					end
					
					if @gravity != 0
					pos2 = p.position
					change = pos.distance pos2
					drop = -(change / 100)*@gravity
					vector2 = Geom::Vector3d.new [ 0, 0, drop]
					@entities.transform_entities(vector2,p)
					end
				
				elsif dist <= @area
					if @vector != [ 0, 0, 0]
					@vector.length = (meandist / 100)*@percent
					@entities.transform_entities(@vector,p)
					end
					
					if @gravity != 0
					pos2 = p.position
					change = pos.distance pos2
					drop = -(change / 100)*@gravity
					vector2 = Geom::Vector3d.new [ 0, 0, drop]
					@entities.transform_entities(vector2,p)
					end
				end
			end
		end
	end
#===================================================================================
end
		mgp = UI::Command.new("Smooth") { Sketchup.active_model.select_tool SculptSmooth.new }
		$btm_sculpt_menu.add_item mgp
		mgp.large_icon = "btm_sculpt4_smooth1.png"
    mgp.small_icon = "btm_sculpt4_smooth1x16.png"
		mgp.tooltip = "Smooth"
		toolbar = $btm_sculpt_toolbar.add_item mgp
		case toolbar.get_last_state
		when 1
			toolbar.restore
		when -1   
			toolbar.show
		end